import java.applet.*;
import java.awt.*;
import java.util.*;

public class Nasubi0 extends Applet implements Runnable{
    
    private int nasubiHP;
    private int stage;
    private int score;
    private Font statusFont;
    private Thread thread;
    private boolean deathLock;
    private int oneUp;
    private int lockTime;
    private NasubiPlane nasubiP;
    private BGMPlayer bgm;
    private Vector enemies;
    private int leftEnemy;
    private Random random;
    private Graphics bgGraphics;
    private Image bgImage;
    private Graphics starGraphics;
    private Image starImage;
    private Hashtable images;
    private AudioClip damageSound;
    private AudioClip deathSound;
    private AudioClip oneUpSound;
    private AudioClip shotSound;
    private int mouseX;
    private int mouseY;
    
    public void init(){
        score = 0;
        statusFont = new Font("TimesRoman", Font.PLAIN, 16);
        thread = null;
        MediaTracker media = new MediaTracker(this);
        bgm = null;
        random = new Random();
        mouseX = 0;
        mouseY = 0;
        bgImage = createImage(320,240);
        starImage = null;
        bgGraphics = bgImage.getGraphics();
        damageSound = getAudioClip(getCodeBase(),"damage.au");
        deathSound = getAudioClip(getCodeBase(),"death.au");
        oneUpSound = getAudioClip(getCodeBase(),"oneup.au");
        shotSound = getAudioClip(getCodeBase(),"shot.au");
        images = new Hashtable();
        images.put("nasubi",getImage(getCodeBase(),"nasubi.gif"));
        images.put("shot",getImage(getCodeBase(),"shot.gif"));
        images.put("death",getImage(getCodeBase(),"death.gif"));
        images.put("mcdonald",getImage(getCodeBase(),"mcdonald.gif"));
        images.put("yoshigyu",getImage(getCodeBase(),"yoshigyu.gif"));
        images.put("peking",getImage(getCodeBase(),"peking.gif"));
        images.put("pekifire",getImage(getCodeBase(),"pekifire.gif"));
        images.put("cat",getImage(getCodeBase(),"cat.gif"));
        images.put("catcore",getImage(getCodeBase(),"catcore.gif"));
        images.put("catcoin",getImage(getCodeBase(),"catcoin.gif"));
        images.put("ave00",getImage(getCodeBase(),"ave00.gif"));
        images.put("ave02",getImage(getCodeBase(),"ave02.gif"));
        images.put("aveshot",getImage(getCodeBase(),"aveshot.gif"));
        images.put("subdog",getImage(getCodeBase(),"subdog.gif"));
        images.put("comet",getImage(getCodeBase(),"comet.gif"));
        images.put("dog",getImage(getCodeBase(),"dog.gif"));
        images.put("dogcore",getImage(getCodeBase(),"dogcore.gif"));
        images.put("meteor",getImage(getCodeBase(),"meteor.gif"));
        images.put("atom",getImage(getCodeBase(),"atom.gif"));
        images.put("radio",getImage(getCodeBase(),"radio.gif"));
        images.put("ribbon",getImage(getCodeBase(),"ribbon.gif"));
        images.put("jungle",getImage(getCodeBase(),"jungle.gif"));
        images.put("jack",getImage(getCodeBase(),"jack.gif"));
        images.put("sparrowc",getImage(getCodeBase(),"sparrowc.gif"));
        images.put("sparrowu",getImage(getCodeBase(),"sparrowu.gif"));
        images.put("sparrowd",getImage(getCodeBase(),"sparrowd.gif"));
        images.put("phoenix",getImage(getCodeBase(),"phoenix.gif"));
        images.put("sparrowb",getImage(getCodeBase(),"sparrowb.gif"));
        images.put("sbeko",getImage(getCodeBase(),"sbeko.gif"));
        images.put("iwambo",getImage(getCodeBase(),"iwambo.gif"));
        images.put("thunder",getImage(getCodeBase(),"thunder.gif"));
        images.put("soji",getImage(getCodeBase(),"soji.gif"));
        images.put("saito",getImage(getCodeBase(),"saito.gif"));
        images.put("anthead",getImage(getCodeBase(),"anthead.gif"));
        images.put("antbody",getImage(getCodeBase(),"antbody.gif"));
        images.put("anttail",getImage(getCodeBase(),"anttail.gif"));
        images.put("antegg",getImage(getCodeBase(),"antegg.gif"));
        images.put("antworm",getImage(getCodeBase(),"antworm.gif"));
        images.put("bluebigm",getImage(getCodeBase(),"bluebigm.gif"));
        images.put("barbados",getImage(getCodeBase(),"barbados.gif"));
        images.put("shakapan",getImage(getCodeBase(),"shakapan.gif"));
        images.put("kabikill",getImage(getCodeBase(),"kabikill.gif"));
        images.put("ufo",getImage(getCodeBase(),"ufo.gif"));
        images.put("invader",getImage(getCodeBase(),"invader.gif"));
        images.put("horse",getImage(getCodeBase(),"horse.gif"));
        images.put("horsef",getImage(getCodeBase(),"horsef.gif"));
        images.put("bluemoai",getImage(getCodeBase(),"bluemoai.gif"));
        images.put("yellow",getImage(getCodeBase(),"yellow.gif"));
        images.put("redangel",getImage(getCodeBase(),"redangel.gif"));
        images.put("greenman",getImage(getCodeBase(),"greenman.gif"));
        images.put("magokoro",getImage(getCodeBase(),"magokoro.gif"));
        images.put("power",getImage(getCodeBase(),"power.gif"));
        images.put("elephant",getImage(getCodeBase(),"elephant.gif"));
        images.put("nose",getImage(getCodeBase(),"nose.gif"));
        images.put("wbear",getImage(getCodeBase(),"wbear.gif"));
        images.put("wbearice",getImage(getCodeBase(),"wbearice.gif"));
        images.put("salad",getImage(getCodeBase(),"salad.gif"));
        images.put("saladsht",getImage(getCodeBase(),"saladsht.gif"));
        images.put("stage9bg",getImage(getCodeBase(),"stage9bg.gif"));
        images.put("mnasubi",getImage(getCodeBase(),"mnasubi.gif"));
        images.put("mnshot",getImage(getCodeBase(),"mnshot.gif"));
        images.put("natto1",getImage(getCodeBase(),"natto1.gif"));
        images.put("natto2",getImage(getCodeBase(),"natto2.gif"));
        images.put("natto",getImage(getCodeBase(),"natto.gif"));
        images.put("nattow",getImage(getCodeBase(),"nattow.gif"));
        for (Enumeration e = images.elements();e.hasMoreElements();){
            media.addImage((Image)(e.nextElement()),0);
        }
        try{
            media.waitForID(0);
        }catch(InterruptedException ex){
            System.err.println(ex);
        }
    }
    
    public void start(){
        nasubiHP = 2;
        stage = 0;
        score = 0;
        deathLock = false;
        oneUp = 1000;
        lockTime = -1;
        nasubiP = null;
        enemies = new Vector();
        if(thread == null){
            thread = new Thread(this);
            thread.start();
        }
    }
    
    public void stop(){
        if(bgm != null){
            bgm.stopPlay();
            bgm = null;
        }
        if(thread != null){
            thread.stop();
            thread = null;
        }
    }
    
    public void run(){
        try{
            while(true){
                if(bgm == null){
                    bgm = (BGMPlayer)getAppletContext().getApplet("bgm");
                }
                switch(stage){
                case 0:
                    if(!bgm.isPlaying()){
                        bgm.play("c1000b1000c1000a1000c1000g1000c1000f1000c1000e1000c1000d1000c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25",true);
                    }
                    break;
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                    if(!bgm.isPlaying()){
                        if(stage == 8){
                            bgm.play("b500c500b500c500b250c250b250c250b125c125b125c125b125c125b125c125b125a125g125f125e125d125c125d125c125d125e125f125g125a125b125a125b125c125a125d125g125e125f125w125",true);
                        }else if(stage == 9){
                            bgm.play("n1000",true);
                        }else if(stage == 10){
                            bgm.play("c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c83d83e83f83e83d83c250g250f250e250d250c250d500d250a250g250f250e250d250e500",true);
                        }else if(leftEnemy > 0){
                            switch(stage){
                            case 1:
                                bgm.play("g250f250e250d250g250f250e250d250g250f250e250d250g250f250e250d250c500e500g500b500c500e500g500f500d500f500a1000d500f500a1000c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25c225w25",true);
                                break;
                            case 2:
                                bgm.play("c250d250e250f250c250d250e250f250c250d250e250f250c250d250e250f250c250d250e250f250g250a250b500c250d250e250f250g250a250b500b250a250g250a250g250f250e250f250e250d250c500",true);
                                break;
                            case 3:
                                bgm.play("c125d125e125c125d125e125w250d125e125f125d125e125f125w250e125f125g125e125f125g125w250f125g125a125f125g125a125w250b125a125g125b125a125g125w250a125g125f125a125g125f125w250g125f125e125g125f125e125w250f125e125d125f125e125b125w250",true);
                                break;
                            case 4:
                                bgm.play("c375c125g375g125c375c125g375g125c375c125g375g125c375c125g375g125b250g250e250c250b250g250e250c250c250d250e250f250g250f250e250d250e250f250g250a250b250a250g250f250",true);
                                break;
                            case 5:
                                bgm.play("c125d125c125f125c125d125c125f125c125d125c125f125c125d125c125f125c125d125c125f125c125d125c125f125c125d125c125f125c125d125c125f125b125a125g125f125e125d125c250",true);
                                break;
                            case 6:
                                bgm.play("f100w25f100w25f100w25f100w25f100w25f100w25f100w25a100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25c100w25f100w25f100w25f100w25f100w25f100w25f100w25f100w25a100w25b100w25b100w25b100w25b100w25b100w25b100w25b100w25b100w25",true);
                                break;
                            case 7:
                                bgm.play("e125d125c125d125c125d125e125c125e125d125c125d125c125d125e125c125e125d125c125d125c125d125e125c125e125d125c125d125c125d125e125c125g100f100e100d100c100a100g100f100e100d100b100a100g100f100e100d100c400",true);
                                break;
                            }
                        }else{
                            bgm.play("e1000d1000c1000d1000c1000d1000e1000c1000e500d500c500d500c500d500e500c500e250d250c250d250c250d250e250c250e250d250c250d250c250d250e250c250a100g100f100e100d100c500b100a100g100f100e100d500",true);
                        }
                    }
                    if(lockTime == -1){
                        int nx = 0;
                        int ny = 0;
                        int cx = mouseX - 16 - nasubiP.getNasubiX();
                        int cy = mouseY - 7 - nasubiP.getNasubiY();
                        if(cx * cx + cy * cy < 64){
                            nx = mouseX - 16;
                        }else{
                            nx = nasubiP.getNasubiX() + (int)((float)cx / Math.sqrt(cx * cx + cy * cy) * 8.0);
                        }
                        if(cx * cx + cy * cy < 64){
                            ny = mouseY - 7;
                        }else{
                            ny = nasubiP.getNasubiY() + (int)((float)cy / Math.sqrt(cx * cx + cy * cy) * 8.0);
                        }
                        nasubiP.setPlane(nx,ny);
                    }
                    nasubiP.moveShot();
                    move();
                    break;
                }
                if(score >= oneUp){
                    oneUpSound.play();
                    oneUp *= 2;
                    nasubiHP++;
                }
                repaint();
                if(lockTime > 0){
                    lockTime--;
                }
                if(stage == 7 && enemies.size() == 0){
                    leftEnemy--;
                    switch(leftEnemy){
                    case 0:
                        bgm.stopPlay();
                        enemies.addElement(new Enemy(false,true,200,10000,400,400,128,128,(Image)images.get("wbear"),1,42,-20));
                        enemies.addElement(new Enemy(false,false,-1,0,288,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,288,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,256,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,256,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,224,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,224,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,192,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,192,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,160,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,160,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,128,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,128,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,96,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,96,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,64,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,64,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,32,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,32,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,0,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,0,240,32,32,(Image)images.get("wbearice"),1,12,0));
                        break;
                    case 20:
                        enemies.addElement(new Enemy(false,false,-1,0,384,56,128,128,(Image)images.get("elephant"),1,40,-1));
                        enemies.addElement(new Enemy(false,true,200,7500,352,104,32,32,(Image)images.get("nose"),1,12,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                        break;
                    case 40:
                        enemies.addElement(new Enemy(false,true,100,5000,352,56,128,128,(Image)images.get("horse"),1,33,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,352,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,384,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,416,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,448,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,24,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,56,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,88,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,120,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,152,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,480,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,448,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,416,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,384,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,352,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,184,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,152,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,120,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,88,32,32,(Image)images.get("horsef"),1,34,-1));
                        enemies.addElement(new Enemy(false,false,-1,0,320,56,32,32,(Image)images.get("horsef"),1,34,-1));
                        break;
                    case 60:
                        enemies.addElement(new Enemy(false,true,50,4000,360,100,40,40,(Image)images.get("antbody"),1,23,0));
                        enemies.addElement(new Enemy(false,false,100,0,320,100,40,40,(Image)images.get("anthead"),1,24,0));
                        enemies.addElement(new Enemy(false,false,50,0,400,100,40,40,(Image)images.get("anttail"),1,25,0));
                        break;
                    case 80:
                        enemies.addElement(new Enemy(false,false,-1,0,320,88,128,32,(Image)images.get("sparrowu"),3,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,320,120,128,32,(Image)images.get("sparrowd"),4,12,0));
                        enemies.addElement(new Enemy(false,true,100,3000,384,56,128,128,(Image)images.get("sparrowc"),5,17,0));
                        break;
                    case 100:
                        enemies.addElement(new Enemy(false,true,50,2000,400,400,40,16,(Image)images.get("dogcore"),1,11,-1));
                        enemies.addElement(new Enemy(true,false,1,0,240,0,80,80,(Image)images.get("dog"),0,12,0));
                        enemies.addElement(new Enemy(true,false,1,0,240,80,80,80,(Image)images.get("dog"),0,12,0));
                        enemies.addElement(new Enemy(true,false,1,0,240,160,80,80,(Image)images.get("dog"),0,12,0));
                        break;
                    case 120:
                        enemies.addElement(new Enemy(true,false,1,0,192,56,128,128,(Image)images.get("cat"),0,3,-1));
                        enemies.addElement(new Enemy(false,true,50,1000,400,400,16,16,(Image)images.get("catcore"),1,4,-1));
                        break;
                    }
                }
                Thread.sleep(100);
            }
        }catch(InterruptedException e){
            System.err.println(e);
        }
    }
    
    synchronized void move(){
        hitCheck();
        if(random.nextInt() % 10 == 0 && leftEnemy > 0){
            Enemy enemy = null;
            switch(stage){
            case 1:
                switch(Math.abs(random.nextInt() % 3)){
                case 0:
                    enemy = new Enemy(false,false,3,10,320,Math.abs(random.nextInt() % 240) - 4,32,8,(Image)images.get("mcdonald"),1,1,0);
                    break;
                case 1:
                    enemy = new Enemy(false,false,5,20,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("yoshigyu"),1,1,0);
                    break;
                case 2:
                    enemy = new Enemy(false,false,3,20,288,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("peking"),1,2,Math.abs(random.nextInt() % 2));
                    break;
                }
                break;
            case 2:
                switch(Math.abs(random.nextInt() % 4)){
                case 0:
                    enemy = new Enemy(false,false,3,10,320,Math.abs(random.nextInt() % 240) - 4,32,8,(Image)images.get("mcdonald"),1,1,0);
                    break;
                case 1:
                    enemy = new Enemy(false,false,3,30,Math.abs(random.nextInt() % 209),Math.abs(random.nextInt() % 2) * 208,32,32,(Image)images.get("ave00"),1,6,0);
                    break;
                case 2:
                    enemy = new Enemy(false,false,5,30,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("ave02"),1,7,0);
                    break;
                case 3:
                    enemy = new Enemy(false,false,10,40,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("subdog"),1,8,0);
                    break;
                }
                break;
            case 3:
                switch(Math.abs(random.nextInt() % 4)){
                case 0:
                    enemy = new Enemy(false,false,3,60,288,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("atom"),2,14,Math.abs(random.nextInt() % 2));
                    break;
                case 1:
                    enemy = new Enemy(false,false,1,50,-16,Math.abs(random.nextInt() % 240) - 8,32,16,(Image)images.get("ribbon"),1,15,0);
                    break;
                case 2:
                    enemy = new Enemy(false,false,5,50,288,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("jungle"),1,16,0);
                    break;
                case 3:
                    enemy = new Enemy(false,false,1,60,320,Math.abs(random.nextInt() % 240) - 16,16,32,(Image)images.get("jack"),1,1,0);
                    break;
                }
                break;
            case 4:
                switch(Math.abs(random.nextInt() % 5)){
                case 0:
                    enemy = new Enemy(false,false,3,10,320,Math.abs(random.nextInt() % 240) - 4,32,8,(Image)images.get("mcdonald"),1,1,0);
                    break;
                case 1:
                    enemy = new Enemy(false,false,10,70,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("sbeko"),1,18,0);
                    break;
                case 2:
                    enemy = new Enemy(false,false,5,80,288,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("iwambo"),1,19,Math.abs(random.nextInt() % 2));
                    break;
                case 3:
                    enemy = new Enemy(false,false,10,70,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("soji"),1,21,0);
                    break;
                case 4:
                    enemy = new Enemy(false,false,5,80,320,nasubiP.getNasubiY() - 8,32,32,(Image)images.get("saito"),1,22,0);
                    break;
                }
                break;
            case 5:
                switch(Math.abs(random.nextInt() % 4)){
                case 0:
                    enemy = new Enemy(false,false,3,90,320,Math.abs(random.nextInt() % 240) - 4,32,8,(Image)images.get("bluebigm"),1,27,0);
                    break;
                case 1:
                    enemy = new Enemy(false,false,1,90,320,Math.abs(random.nextInt() % 240) - 8,32,16,(Image)images.get("barbados"),1,28,score);
                    break;
                case 2:
                    enemy = new Enemy(false,false,30,100,320,Math.abs(random.nextInt() % 240) - 32,64,64,(Image)images.get("kabikill"),1,30,0);
                    break;
                case 3:
                    enemy = new Enemy(false,false,5,100,320,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("ufo"),1,31,0);
                    break;
                }
                break;
            case 6:
                enemy = new Enemy(false,false,5,200,288,Math.abs(random.nextInt() % 240) - 32,32,64,(Image)images.get("bluemoai"),1,35,5);
                break;
            case 9:
                enemy = new Enemy(false,false,10,1000,288,Math.abs(random.nextInt() % 240) - 16,32,32,(Image)images.get("mnasubi"),1,45,Math.abs(random.nextInt() % 2));
                break;
            }
            if(stage != 7){
                enemies.addElement(enemy);
            }
        }
        int i = 0;
        while(i < enemies.size()){
            int enmx = ((Enemy)enemies.elementAt(i)).getX();
            int enmy = ((Enemy)enemies.elementAt(i)).getY();
            switch(((Enemy)enemies.elementAt(i)).getMoveType()){
            case 1:
                enmx -= 16;
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -16){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,((Enemy)enemies.elementAt(i)).getY());
                    i++;
                }
                break;
            case 2:
                if(enmy < -1){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() / 2){
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy + 16);
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy - 16);
                }
                if(random.nextInt() % 5 == 0){
                    enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX(),((Enemy)enemies.elementAt(i)).getY() + 8,16,16,(Image)images.get("pekifire"),1,1,0));
                }
                i++;
                break;
            case 3:
                if(enemies.size() == 2 || ((Enemy)enemies.elementAt(i)).getValue() != -1){
                    if(nasubiP.getNasubiY() > ((Enemy)enemies.elementAt(i)).getY() + 44){
                        ((Enemy)enemies.elementAt(i)).setValue(0);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }
                }
                if(enmy > 0 && ((Enemy)enemies.elementAt(i)).getValue() == 0){
                   enmy -= 8;
                }else if(enmy < 112 && ((Enemy)enemies.elementAt(i)).getValue() == 1){
                   enmy += 8;
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy);
                i++;
                break;
            case 4:
                if(enemies.size() == 2 && ((Enemy)enemies.elementAt(i)).getValue() == -1){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() > -1){
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(0)).getX() + 8,((Enemy)enemies.elementAt(0)).getY() + 44);
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0 && random.nextInt() % 10 == 0){
                        ((Enemy)enemies.elementAt(i)).setValue(10);
                    }else if(((Enemy)enemies.elementAt(i)).getValue() > 0){
                        enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX() + 16,((Enemy)enemies.elementAt(i)).getY() + (random.nextInt() % 8) + 48,16,8,(Image)images.get("catcoin"),1,5,random.nextInt() % 16));
                        int threev = ((Enemy)enemies.elementAt(i)).getValue() - 1;
                        ((Enemy)enemies.elementAt(i)).setValue(threev);
                    }
                }
                i++;
                break;
            case 5:
                enmx -= (int)Math.sqrt(256 - ((Enemy)enemies.elementAt(i)).getValue() * ((Enemy)enemies.elementAt(i)).getValue());
                enmy += ((Enemy)enemies.elementAt(i)).getValue();
                if(enmx < -16 || enmy < -8 || enmy > 240){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    i++;
                }
                break;
            case 6:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(enmy == 0){
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(-1);
                    }
                }
                if(enmy < -1){
                    enemies.removeElementAt(i);
                    continue;
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() / 2){
                    enemies.removeElementAt(i);
                    continue;
                }
                if(((Enemy)enemies.elementAt(i)).getValue() < 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy - 4);
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy + 4);
                }
                if(nasubiP.getNasubiY() > enmy - 16 && nasubiP.getNasubiY() < enmy + 32 && Math.abs(((Enemy)enemies.elementAt(i)).getValue()) < 2){
                    if(nasubiP.getNasubiX() > ((Enemy)enemies.elementAt(i)).getX()){
                        enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX() + 24,((Enemy)enemies.elementAt(i)).getY() + 12,8,8,(Image)images.get("aveshot"),1,9,0));
                    }else{
                        enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX(),((Enemy)enemies.elementAt(i)).getY() + 12,8,8,(Image)images.get("aveshot"),1,9,2));
                    }
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() * 2);
                }
                i++;
                break;
            case 7:
                if(enmx < -1){
                    enemies.removeElementAt(i);
                    continue;
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 4,((Enemy)enemies.elementAt(i)).getY());
                if(nasubiP.getNasubiX() > enmx - 32 && nasubiP.getNasubiX() < enmx + 32 && ((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(nasubiP.getNasubiY() > ((Enemy)enemies.elementAt(i)).getY()){
                        enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX() + 12,((Enemy)enemies.elementAt(i)).getY() + 24,8,8,(Image)images.get("aveshot"),1,9,3));
                    }else{
                        enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX() + 12,((Enemy)enemies.elementAt(i)).getY(),8,8,(Image)images.get("aveshot"),1,9,1));
                    }
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                }
                i++;
                break;
            case 8:
                if(enmy > nasubiP.getNasubiY() - 12 && enmy < nasubiP.getNasubiY() - 4){
                    enmy = nasubiP.getNasubiY() - 8;
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("comet"),1,10,16));
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }
                }else if(enmy < nasubiP.getNasubiY() - 8){
                    enmy += 4;
                }else{
                    enmy -= 4;
                }
                enmx -= 4;
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -16){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    i++;
                }
                break;
            case 9:
                switch(((Enemy)enemies.elementAt(i)).getValue()){
                case 0:
                    enmx += 8;
                    if(enmx > 320 - ((Enemy)enemies.elementAt(i)).getSizeX() / 2){
                        enemies.removeElementAt(i);
                        continue;
                    }
                    break;
                case 1:
                    enmy -= 8;
                    if(enmy < -1){
                        enemies.removeElementAt(i);
                        continue;
                    }
                    break;
                case 2:
                    enmx -= 8;
                    if(enmx < -1){
                        enemies.removeElementAt(i);
                        continue;
                    }
                    break;
                case 3:
                    enmy += 8;
                    if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() / 2){
                        enemies.removeElementAt(i);
                        continue;
                    }
                    break;
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                i++;
                break;
            case 10:
                if(((Enemy)enemies.elementAt(i)).getValue() / ((Enemy)enemies.elementAt(i)).getHP() != (float)((Enemy)enemies.elementAt(i)).getValue() / (float)((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }else if(((Enemy)enemies.elementAt(i)).getValue() / ((Enemy)enemies.elementAt(i)).getHP() > -16){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - ((Enemy)enemies.elementAt(i)).getHP());
                }
                enmx += ((Enemy)enemies.elementAt(i)).getValue() / ((Enemy)enemies.elementAt(i)).getHP();
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -32){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,((Enemy)enemies.elementAt(i)).getY());
                    i++;
                }
                break;
            case 11:
                if(random.nextInt() % 20 == 0 && ((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(240,Math.abs(random.nextInt() % 3) * 80 + 48);
                    enemies.addElement(new Enemy(false,false,-1,0,240,0,80,80,(Image)images.get("meteor"),1,13,0));
                    enemies.addElement(new Enemy(false,false,-1,0,240,80,80,80,(Image)images.get("meteor"),1,13,0));
                    enemies.addElement(new Enemy(false,false,-1,0,240,160,80,80,(Image)images.get("meteor"),1,13,0));
                    ((Enemy)enemies.elementAt(i)).setValue(20);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() > 0){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                }
                if(enemies.size() == 4 && ((Enemy)enemies.elementAt(i)).getValue() == -1){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }
                i++;
                break;
            case 12:
                i++;
                break;
            case 13:
                if(((Enemy)enemies.elementAt(i)).getHP() != -1){
                    deathSound.play();
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("comet"),1,10,16));
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy + 48,32,32,(Image)images.get("comet"),1,10,16));
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy + 24,32,32,(Image)images.get("comet"),1,10,16));
                    enemies.removeElementAt(i);
                    continue;
                }
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -80){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,((Enemy)enemies.elementAt(i)).getY());
                    i++;
                }
                break;
            case 14:
                if(enmy < -1){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() / 2){
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy + 4);
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i)).getX(),enmy - 4);
                }
                if(random.nextInt() % 10 == 0){
                    enemies.addElement(new Enemy(true,false,1,0,((Enemy)enemies.elementAt(i)).getX(),Math.abs(random.nextInt() % (((Enemy)enemies.elementAt(i)).getSizeY() - 1)) + ((Enemy)enemies.elementAt(i)).getY(),2,2,(Image)images.get("radio"),1,1,0));
                }
                i++;
                break;
            case 15:
                int fifteenx = nasubiP.getNasubiX() - enmx - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                int fifteeny = nasubiP.getNasubiY() - enmy - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                if(fifteenx * fifteenx + fifteeny * fifteeny < 9){
                    enmx = nasubiP.getNasubiX() - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                    enmy = nasubiP.getNasubiY() - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                }else{
                    enmx += (int)((float)fifteenx / Math.sqrt(fifteenx * fifteenx + fifteeny * fifteeny) * 3.0);
                    enmy += (int)((float)fifteeny / Math.sqrt(fifteenx * fifteenx + fifteeny * fifteeny) * 3.0);
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                i++;
                break;
            case 16:
                if(enmy > nasubiP.getNasubiY() - 12 && enmy < nasubiP.getNasubiY() - 4){
                    enmy = nasubiP.getNasubiY() - 8;
                    enmx -= 16;
                }else if(enmy < nasubiP.getNasubiY() - 8){
                    enmy += 4;
                }else{
                    enmy -= 4;
                }
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -16){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    i++;
                }
                break;
            case 17:
                if(((Enemy)enemies.elementAt(i)).getValue() == -1){
                    if(random.nextInt() % 20 == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,128,enmy + 60,128,8,(Image)images.get("sparrowb"),1,12,0));
                        enemies.addElement(new Enemy(false,false,-1,0,128,enmy + 61,128,8,(Image)images.get("sparrowb"),1,12,0));
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }else{
                        if(enmy > nasubiP.getNasubiY() - 60 && enmy < nasubiP.getNasubiY() - 52){
                            enmy = nasubiP.getNasubiY() - 56;
                            enemies.addElement(new Enemy(false,false,-1,0,128,enmy + 60,128,8,(Image)images.get("sparrowb"),1,1,0));
                            ((Enemy)enemies.elementAt(i)).setValue(0);
                        }else if(enmy < nasubiP.getNasubiY() - 56){
                            enmy += 4;
                        }else{
                            enmy -= 4;
                        }
                        ((Enemy)enemies.elementAt(0)).setEnemy(128,enmy + 32);
                        ((Enemy)enemies.elementAt(1)).setEnemy(128,enmy + 64);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(enmx > 200){
                        ((Enemy)enemies.elementAt(i - 2)).setEnemy(enmx - 72,enmy + 32);
                        ((Enemy)enemies.elementAt(i - 1)).setEnemy(enmx - 72,enmy + 64);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy);
                    }else{
                        ((Enemy)enemies.elementAt(i - 2)).setEnemy(128,enmy + 32);
                        ((Enemy)enemies.elementAt(i - 1)).setEnemy(128,enmy + 64);
                        ((Enemy)enemies.elementAt(i)).setEnemy(192,enmy);
                    }
                    if(enemies.size() == 3 && enmx == 192){
                        ((Enemy)enemies.elementAt(i)).setValue(-1);
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                    if(((Enemy)enemies.elementAt(0)).getY() == enmy){
                        ((Enemy)enemies.elementAt(i)).setValue(110);
                    }else{
                        ((Enemy)enemies.elementAt(0)).setEnemy(128,((Enemy)enemies.elementAt(0)).getY() - 4);
                        ((Enemy)enemies.elementAt(1)).setEnemy(128,((Enemy)enemies.elementAt(1)).getY() + 4);
                        ((Enemy)enemies.elementAt(3)).setEnemy(((Enemy)enemies.elementAt(3)).getX() - 16,((Enemy)enemies.elementAt(3)).getY() - 4);
                        ((Enemy)enemies.elementAt(4)).setEnemy(((Enemy)enemies.elementAt(4)).getX() - 16,((Enemy)enemies.elementAt(4)).getY() + 4);
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 10){
                    if(((Enemy)enemies.elementAt(0)).getY() == enmy + 32){
                        ((Enemy)enemies.elementAt(i)).setValue(-1);
                        enemies.removeElementAt(3);
                        enemies.removeElementAt(3);
                    }else{
                        ((Enemy)enemies.elementAt(0)).setEnemy(128,((Enemy)enemies.elementAt(0)).getY() + 4);
                        ((Enemy)enemies.elementAt(1)).setEnemy(128,((Enemy)enemies.elementAt(1)).getY() - 4);
                        ((Enemy)enemies.elementAt(3)).setEnemy(((Enemy)enemies.elementAt(3)).getX() - 16,((Enemy)enemies.elementAt(3)).getY());
                        ((Enemy)enemies.elementAt(4)).setEnemy(((Enemy)enemies.elementAt(4)).getX() - 16,((Enemy)enemies.elementAt(4)).getY());
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() % 5 == 0){
                    if(random.nextInt() % 2 == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,192,(random.nextInt() % 32) + enmy + 56,16,16,(Image)images.get("phoenix"),1,1,0));
                        ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    }
                }else{
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                }
                i++;
                break;
            case 18:
                if(nasubiP.howManyShots() != 0){
                    int eighteenx = nasubiP.getShotX(0) - enmx - 8;
                    int eighteeny = nasubiP.getShotY(0) - enmy - 15;
                    if(eighteenx * eighteenx + eighteeny * eighteeny < 64){
                        enmx = nasubiP.getShotX(0) - 8;
                        enmy = nasubiP.getShotY(0) - 15;
                    }else{
                        enmx += (int)((float)eighteenx / Math.sqrt(eighteenx * eighteenx + eighteeny * eighteeny) * 8.0);
                        enmy += (int)((float)eighteeny / Math.sqrt(eighteenx * eighteenx + eighteeny * eighteeny) * 8.0);
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                }
                i++;
                break;
            case 19:
                if(enmy < -1){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() / 2){
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 16);
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 16);
                }
                if(random.nextInt() % 10 == 0){
                    enemies.addElement(new Enemy(true,false,1,0,enmx,enmy + 8,16,16,(Image)images.get("thunder"),1,20,0));
                }
                i++;
                break;
            case 20:
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 16,enmy + random.nextInt() % 9);
                    i++;
                }
                break;
            case 21:
                int twentyonex = nasubiP.getNasubiX() - enmx + 32;
                int twentyoney = nasubiP.getNasubiY() - enmy - 8;
                if(twentyonex * twentyonex + twentyoney * twentyoney < 1024){
                    enmx = nasubiP.getNasubiX() + 32;
                    enmy = nasubiP.getNasubiY() - 8;
                }else{
                    enmx += (int)((float)twentyonex / Math.sqrt(twentyonex * twentyonex + twentyoney * twentyoney) * 32.0);
                    enmy += (int)((float)twentyoney / Math.sqrt(twentyonex * twentyonex + twentyoney * twentyoney) * 32.0);
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                i++;
                break;
            case 22:
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,enmy);
                    i++;
                }
                break;
            case 23:
                if(enemies.size() == 1){
                    enemies.addElement(new Enemy(false,false,50,0,200,enmy,40,40,(Image)images.get("anthead"),1,24,0));
                    enemies.addElement(new Enemy(false,false,50,0,280,enmy,40,40,(Image)images.get("anttail"),1,25,0));
                }
                if(enmy == 200 && nasubiP.getNasubiY() > 191){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,160);
                }else if(enmy == 0 && nasubiP.getNasubiY() < 33){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,40);
                }else if(nasubiP.getNasubiY() - enmy > 12 || (enmy == 200 && nasubiP.getNasubiY() > 191)){
                    if(enmy < 16){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,0);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 16);
                    }
                }else if(nasubiP.getNasubiY() - enmy < 12 || (enmy == 0 && nasubiP.getNasubiY() < 33)){
                    if(enmy > 184){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,200);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 16);
                    }
                }
                i++;
                break;
            case 24:
                if(i == 1){
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        if(Math.abs(nasubiP.getNasubiY() - enmy - 12) < 5){
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,nasubiP.getNasubiY() - 12);
                            ((Enemy)enemies.elementAt(i)).setValue(1);
                        }else if(nasubiP.getNasubiY() - enmy > 12){
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                        }else if(nasubiP.getNasubiY() - enmy < 12){
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                        }
                    }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                        if(enmx < 16){
                            ((Enemy)enemies.elementAt(i)).setEnemy(0,enmy);
                            ((Enemy)enemies.elementAt(i)).setValue(2);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 16,enmy);
                        }
                    }else if(((Enemy)enemies.elementAt(i)).getValue() == 2){
                        if(enmx > 184){
                            ((Enemy)enemies.elementAt(i)).setEnemy(200,enmy);
                            ((Enemy)enemies.elementAt(i)).setValue(0);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 16,enmy);
                        }
                    }
                }
                if(((Enemy)enemies.elementAt(i)).getHP() < 51 && enmx == 200){
                    ((Enemy)enemies.elementAt(i - 1)).setValue(1);
                }
                if(enmx > 200){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy);
                }
                if(((Enemy)enemies.elementAt(i - 1)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i - 1)).setEnemy(((Enemy)enemies.elementAt(i)).getX() + 40,((Enemy)enemies.elementAt(i)).getY());
                }
                i++;
                break;
            case 25:
                if(i < 3){
                    if(random.nextInt() % 3 == 0){
                        enemies.addElement(new Enemy(false,false,1,0,enmx + 32,enmy + 16,8,8,(Image)images.get("antegg"),1,26,Math.abs(random.nextInt() % 2)));
                    }
                    if(((Enemy)enemies.elementAt(0)).getValue() == 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(0)).getX() + 40,((Enemy)enemies.elementAt(0)).getY());
                    }else if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        if(nasubiP.getNasubiY() - enmy < 12){
                            ((Enemy)enemies.elementAt(i)).setValue(1);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setValue(2);
                        }
                    }
                    if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                        if(enmy < 0){
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,0);
                            ((Enemy)enemies.elementAt(i)).setValue(3);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                        }
                    }else if(((Enemy)enemies.elementAt(i)).getValue() == 2){
                        if(enmy > 196){
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,200);
                            ((Enemy)enemies.elementAt(i)).setValue(3);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                        }
                    }else if(((Enemy)enemies.elementAt(i)).getValue() == 3){
                        if(enmx < -16){
                            ((Enemy)enemies.elementAt(i)).setEnemy(-20,enmy);
                            ((Enemy)enemies.elementAt(i)).setValue(4);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 4,enmy);
                        }
                    }else  if(((Enemy)enemies.elementAt(i)).getValue() == 4){
                        if(enmx > 276){
                            ((Enemy)enemies.elementAt(i)).setEnemy(280,enmy);
                            ((Enemy)enemies.elementAt(i)).setValue(0);
                        }else{
                            ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 4,enmy);
                        }
                    }
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(((Enemy)enemies.elementAt(i - 2)).getX() + 40,((Enemy)enemies.elementAt(i - 2)).getY());
                }
                i++;
                break;
            case 26:
                if(random.nextInt() % 10 == 0){
                    enemies.addElement(new Enemy(false,false,1,0,enmx - 4,enmy - 4,16,16,(Image)images.get("antworm"),1,15,0));
                    enemies.removeElementAt(i);
                    continue;
                }
                if(enmy < 8 || enmy > 232){
                    enemies.removeElementAt(i);
                    continue;
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 8 + (((Enemy)enemies.elementAt(i)).getValue() * 16));
                i++;
                break;
            case 27:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(enmx < 17){
                        ((Enemy)enemies.elementAt(i)).setEnemy(0,enmy);
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 16,enmy);
                    }
                    i++;
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                    if(Math.abs(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8) < 9){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,nasubiP.getNasubiY() + 8 - (((Enemy)enemies.elementAt(i)).getSizeY() / 2));
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                    }else if(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8 > 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 8);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 8);
                    }
                    i++;
                }else{
                    if(enmx > 320){
                        enemies.removeElementAt(i);
                        continue;
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 16,enmy);
                        i++;
                    }
                }
                break;
            case 28:
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else if(((Enemy)enemies.elementAt(i)).getValue() != score){
                    enemies.addElement(new Enemy(true,false,-1,0,enmx - 16,enmy - 24,64,64,(Image)images.get("shakapan"),1,29,0));
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 16,enmy);
                    i++;
                }
                break;
            case 29:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                    i++;
                }else{
                    enemies.removeElementAt(i);
                    continue;
                }
                break;
            case 30:
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 4,enmy);
                    i++;
                }
                break;
            case 31:
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy);
                }
                if(random.nextInt() % 20 == 0){
                    enemies.addElement(new Enemy(false,false,3,90,enmx,enmy + 8,32,16,(Image)images.get("invader"),1,32,Math.abs(random.nextInt() % 2)));
                }
                i++;
                break;
            case 32:
                if(enmx < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else if(enmy < 1){
                    if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,0);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(0);
                    }
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() - 1){
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,240 - ((Enemy)enemies.elementAt(i)).getSizeY());
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 16);
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 16);
                }
                i++;
                break;
            case 33:
                if(i == 0 && enmx == 160){
                    ((Enemy)enemies.elementAt(i)).setValue(0);
                }else if(enmx > 160){
                    int thirtythreex = 160;
                    if(enmx > 168){
                        thirtythreex = enmx - 8;
                    }
                    for(int thirtythreej = 1;thirtythreej < 21;thirtythreej++){
                        ((Enemy)enemies.elementAt(thirtythreej + i)).setEnemy(((Enemy)enemies.elementAt(thirtythreej + i)).getX() + thirtythreex - enmx,((Enemy)enemies.elementAt(thirtythreej + i)).getY());
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(thirtythreex,enmy);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(enemies.size() < 21){
                        enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("horsef"),1,34,-1));
                    }
                    if(enmy - nasubiP.getNasubiY() + 56 > 0){
                        for(int thirtythreei = 1;thirtythreei < enemies.size();thirtythreei++){
                            ((Enemy)enemies.elementAt(thirtythreei)).setValue(0);
                        }
                    }else{
                        for(int thirtythreei = 1;thirtythreei < enemies.size();thirtythreei++){
                            ((Enemy)enemies.elementAt(thirtythreei)).setValue(1);
                        }
                    }
                    if(random.nextInt() % 30 == 0){
                        ((Enemy)enemies.elementAt(Math.abs(random.nextInt() % (enemies.size() - 1)) + 1)).damage();
                    }
                }
                i++;
                break;
            case 34:
                if(((Enemy)enemies.elementAt(i)).getHP() != -1 && ((Enemy)enemies.elementAt(i)).getValue() != -1){
                    ((Enemy)enemies.elementAt(i)).setValue(2);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(enmx == 128 && enmy != 24){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                    }else if(enmx != 288 && enmy == 24){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 4,enmy);
                    }else if(enmx == 288 && enmy != 184){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 4,enmy);
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                    if(enmx == 128 && enmy != 184){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                    }else if(enmx != 128 && enmy == 24){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 4,enmy);
                    }else if(enmx == 288 && enmy != 24){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 4,enmy);
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 2){
                    if(enmx < -24){
                        enemies.removeElementAt(i);
                        continue;
                    }
                    if(Math.abs(enmy - nasubiP.getNasubiY() + 8) < 2){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,nasubiP.getNasubiY() - 8);
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                    }else if(enmy - nasubiP.getNasubiY() + 8 > 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy - 2);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy + 2);
                    }
                }
                i++;
                break;
            case 35:
                if(((Enemy)enemies.elementAt(i)).getValue() != ((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    int thirtyfive = Math.abs(random.nextInt() % 4);
                    switch(thirtyfive){
                    case 0:
                        enemies.addElement(new Enemy(false,false,2,150,enmx + (random.nextInt() % 32),enmy + 16 + (random.nextInt() % 48),32,32,(Image)images.get("yellow"),1,36,2));
                        break;
                    case 1:
                        enemies.addElement(new Enemy(false,false,2,150,enmx + (random.nextInt() % 32),enmy + 16 + (random.nextInt() % 48),32,32,(Image)images.get("redangel"),1,37,2));
                        break;
                    case 2:
                        enemies.addElement(new Enemy(false,false,2,150,enmx + 8 + (random.nextInt() % 40),enmy + 16 + (random.nextInt() % 48),16,32,(Image)images.get("greenman"),1,38,2));
                        break;
                    case 3:
                        enemies.addElement(new Enemy(false,false,2,150,enmx + (random.nextInt() % 32),enmy + 16 + (random.nextInt() % 48),32,32,(Image)images.get("power"),1,39,2));
                        break;
                    }
                }
                if(Math.abs(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8) < 4){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,nasubiP.getNasubiY() + 8 - (((Enemy)enemies.elementAt(i)).getSizeY() / 2));
                }else if(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8 < 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                }
                if(random.nextInt() % 30 == 0){
                    enemies.addElement(new Enemy(false,false,3,90,enmx,((Enemy)enemies.elementAt(i)).getY() + 28 + (random.nextInt() % 28),32,8,(Image)images.get("bluebigm"),1,27,0));
                }
                i++;
                break;
            case 36:
                if(((Enemy)enemies.elementAt(i)).getValue() != ((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    enemies.addElement(new Enemy(false,false,((Enemy)enemies.elementAt(i)).getHP(),150,enmx + (random.nextInt() % 32),enmy + (random.nextInt() % 32),32,32,(Image)images.get("yellow"),1,36,((Enemy)enemies.elementAt(i)).getHP()));
                }
                int thirtysixx = nasubiP.getNasubiX() - enmx - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                int thirtysixy = nasubiP.getNasubiY() - enmy - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                if(thirtysixx * thirtysixx + thirtysixy * thirtysixy < 9){
                    enmx = nasubiP.getNasubiX() - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                    enmy = nasubiP.getNasubiY() - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                }else{
                    enmx += (int)((float)thirtysixx / Math.sqrt(thirtysixx * thirtysixx + thirtysixy * thirtysixy) * 3.0);
                    enmy += (int)((float)thirtysixy / Math.sqrt(thirtysixx * thirtysixx + thirtysixy * thirtysixy) * 3.0);
                }
                ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                i++;
                break;
            case 37:
                if(((Enemy)enemies.elementAt(i)).getValue() != ((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    enemies.addElement(new Enemy(false,false,((Enemy)enemies.elementAt(i)).getHP(),150,enmx + (random.nextInt() % 32),enmy + (random.nextInt() % 32),32,32,(Image)images.get("redangel"),1,37,((Enemy)enemies.elementAt(i)).getHP()));
                }
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,enmy);
                    i++;
                }
                break;
            case 38:
                if(((Enemy)enemies.elementAt(i)).getValue() != ((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    enemies.addElement(new Enemy(false,false,((Enemy)enemies.elementAt(i)).getHP(),150,enmx + (random.nextInt() % 16),enmy + (random.nextInt() % 32),16,32,(Image)images.get("greenman"),1,38,((Enemy)enemies.elementAt(i)).getHP()));
                }
                if(enmy > nasubiP.getNasubiY() - 12 && enmy < nasubiP.getNasubiY() - 4){
                    enmy = nasubiP.getNasubiY() - 8;
                    enemies.addElement(new Enemy(true,false,-1,0,enmx + 8,enmy + 8,16,16,(Image)images.get("magokoro"),1,1,0));
                }else if(enmy < nasubiP.getNasubiY() - 8){
                    enmy += 4;
                }else{
                    enmy -= 4;
                }
                enmx -= 4;
                if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < -16){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    i++;
                }
                break;
            case 39:
                if(((Enemy)enemies.elementAt(i)).getValue() != ((Enemy)enemies.elementAt(i)).getHP()){
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    enemies.addElement(new Enemy(false,false,((Enemy)enemies.elementAt(i)).getHP(),150,enmx + (random.nextInt() % 32),enmy + (random.nextInt() % 32),32,32,(Image)images.get("power"),1,39,((Enemy)enemies.elementAt(i)).getHP()));
                }
                if(Math.abs(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8) < 16){
                    if(enmx + (((Enemy)enemies.elementAt(i)).getSizeX() / 2) - nasubiP.getNasubiX() - 16 < 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx + 32,enmy);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,enmy);
                    }
                }else if(Math.abs(enmx + (((Enemy)enemies.elementAt(i)).getSizeX() / 2) - nasubiP.getNasubiX() - 16) < 32){
                    if(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8 < 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 32);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 32);
                    }
                }
                i++;
                break;
            case 40:
                if(i == 0 && enmx == 192){
                    ((Enemy)enemies.elementAt(0)).setValue(0);
                    ((Enemy)enemies.elementAt(1)).setValue(0);
                    ((Enemy)enemies.elementAt(2)).setValue(0);
                    ((Enemy)enemies.elementAt(3)).setValue(0);
                    ((Enemy)enemies.elementAt(4)).setValue(0);
                    ((Enemy)enemies.elementAt(5)).setValue(0);
                    ((Enemy)enemies.elementAt(6)).setValue(0);
                }else if(enmx > 192){
                    if(enmx < 200){
                        enmx = 192;
                    }else{
                        enmx -= 8;
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    ((Enemy)enemies.elementAt(i + 1)).setEnemy(enmx - 32,enmy + 48);
                    ((Enemy)enemies.elementAt(i + 2)).setEnemy(enmx - 64,enmy + 48);
                    ((Enemy)enemies.elementAt(i + 3)).setEnemy(enmx - 64,enmy + 48);
                    ((Enemy)enemies.elementAt(i + 4)).setEnemy(enmx - 64,enmy + 48);
                    ((Enemy)enemies.elementAt(i + 5)).setEnemy(enmx - 64,enmy + 48);
                    ((Enemy)enemies.elementAt(i + 6)).setEnemy(enmx - 64,enmy + 48);
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    if(Math.abs(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8) < 4){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,nasubiP.getNasubiY() + 8 - (((Enemy)enemies.elementAt(i)).getSizeY() / 2));
                        ((Enemy)enemies.elementAt(1)).setEnemy(enmx - 32,nasubiP.getNasubiY() + 60 - (((Enemy)enemies.elementAt(i)).getSizeY() / 2));
                    }else if(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8 < 0){
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 4);
                        ((Enemy)enemies.elementAt(1)).setEnemy(enmx - 32,enmy + 44);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 4);
                        ((Enemy)enemies.elementAt(1)).setEnemy(enmx - 32,enmy + 52);
                    }
                }
                i++;
                break;
            case 41:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    int fortyonex = nasubiP.getNasubiX() - enmx - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                    int fortyoney = nasubiP.getNasubiY() - enmy - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                    if(fortyonex * fortyonex + fortyoney * fortyoney < 16){
                        enmx = nasubiP.getNasubiX() - (((Enemy)enemies.elementAt(i)).getSizeX() / 2) + 16;
                        enmy = nasubiP.getNasubiY() - (((Enemy)enemies.elementAt(i)).getSizeY() / 2) + 8;
                    }else{
                        enmx += (int)((float)fortyonex / Math.sqrt(fortyonex * fortyonex + fortyoney * fortyoney) * 4.0);
                        enmy += (int)((float)fortyoney / Math.sqrt(fortyonex * fortyonex + fortyoney * fortyoney) * 4.0);
                    }
                    fortyonex = ((Enemy)enemies.elementAt(i - 1)).getX() - enmx;
                    fortyoney = ((Enemy)enemies.elementAt(i - 1)).getY() - enmy;
                    if(fortyonex * fortyonex + fortyoney * fortyoney > 1024){
                        enmx = ((Enemy)enemies.elementAt(i - 1)).getX() - (int)((float)fortyonex / Math.sqrt(fortyonex * fortyonex + fortyoney * fortyoney) * 32.0);
                        enmy = ((Enemy)enemies.elementAt(i - 1)).getY() - (int)((float)fortyoney / Math.sqrt(fortyonex * fortyonex + fortyoney * fortyoney) * 32.0);
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                }
                i++;
                break;
            case 42:
                if(((Enemy)enemies.elementAt(i)).getValue() < 0){
                    if(((Enemy)enemies.elementAt(i + 1)).getY() < 24){
                        for(int fortytwoi = i + 1;fortytwoi < i + 21;fortytwoi += 2){
                            ((Enemy)enemies.elementAt(fortytwoi)).setEnemy(((Enemy)enemies.elementAt(fortytwoi)).getX(),((Enemy)enemies.elementAt(fortytwoi)).getY() + 8);
                            ((Enemy)enemies.elementAt(fortytwoi + 1)).setEnemy(((Enemy)enemies.elementAt(fortytwoi + 1)).getX(),((Enemy)enemies.elementAt(fortytwoi + 1)).getY() - 8);
                        }
                    }
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() + 1);
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(192,56);
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                }else{
                    enmy += random.nextInt() % 16;
                    if(enmy < 0){
                        enmy = 0;
                    }else if(enmy > 112){
                        enmy = 112;
                    }
                    ((Enemy)enemies.elementAt(i + 2)).setEnemy(((Enemy)enemies.elementAt(i + 2)).getX(),enmy + 128);
                    ((Enemy)enemies.elementAt(i + 1)).setEnemy(((Enemy)enemies.elementAt(i + 1)).getX(),enmy - 32);
                    for(int fortytwoi = i + 20;fortytwoi > i + 2;fortytwoi--){
                        ((Enemy)enemies.elementAt(fortytwoi)).setEnemy(((Enemy)enemies.elementAt(fortytwoi)).getX(),((Enemy)enemies.elementAt(fortytwoi - 2)).getY());
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    if(enemies.size() == 21){
                        enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy + 48,32,32,(Image)images.get("wbearice"),1,1,0));
                    }
                }
                i++;
                break;
            case 43:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0 && ((Enemy)enemies.elementAt(i)).getHP() < 200){
                    ((Enemy)enemies.elementAt(i)).setValue(1);
                    enemies.addElement(new Enemy(false,false,-1,0,enmx - 32,enmy + 104 + random.nextInt() % 104,32,32,(Image)images.get("saladsht"),1,44,Math.abs(random.nextInt() % 2)));
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1 && ((Enemy)enemies.elementAt(i)).getHP() < 150){
                    ((Enemy)enemies.elementAt(i)).setValue(2);
                    enemies.addElement(new Enemy(false,false,-1,0,enmx - 32,enmy + 104 + random.nextInt() % 104,32,32,(Image)images.get("saladsht"),1,44,Math.abs(random.nextInt() % 2)));
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 2 && ((Enemy)enemies.elementAt(i)).getHP() < 100){
                    ((Enemy)enemies.elementAt(i)).setValue(3);
                    enemies.addElement(new Enemy(false,false,-1,0,enmx - 32,enmy + 104 + random.nextInt() % 104,32,32,(Image)images.get("saladsht"),1,44,Math.abs(random.nextInt() % 2)));
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0 || ((Enemy)enemies.elementAt(i)).getValue() == 2){
                    if(random.nextInt() % 10 == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy + 104 + random.nextInt() % 104,32,32,(Image)images.get("saladsht"),1,1,0));
                    }
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1 || ((Enemy)enemies.elementAt(i)).getValue() == 3){
                    if(random.nextInt() % 15 == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,enmx,nasubiP.getNasubiY() - 8,32,32,(Image)images.get("saladsht"),1,1,0));
                    }
                }
                i++;
                break;
            case 44:
                if(((Enemy)enemies.elementAt(i)).getHP() != -1){
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("saladsht"),1,44,((Enemy)enemies.elementAt(i)).getValue()));
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("saladsht"),1,1,0));
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        enmy += Math.abs(random.nextInt() % 16);
                        if(enmy > 208){
                            enmy = 208;
                            ((Enemy)enemies.elementAt(i)).setValue(1);
                        }
                    }else{
                        enmy -= Math.abs(random.nextInt() % 16);
                        if(enmy < 0){
                            enmy = 0;
                            ((Enemy)enemies.elementAt(i)).setValue(0);
                        }
                    }
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy);
                    i++;
                }
                break;
            case 45:
                if(enmx < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else if(enmy < 1){
                    if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,0);
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(0);
                    }
                }else if(enmy > 240 - ((Enemy)enemies.elementAt(i)).getSizeY() - 1){
                    if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                        ((Enemy)enemies.elementAt(i)).setValue(2);
                        ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 32,240 - ((Enemy)enemies.elementAt(i)).getSizeY());
                    }else{
                        ((Enemy)enemies.elementAt(i)).setValue(1);
                    }
                }
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy + 16);
                }else if(((Enemy)enemies.elementAt(i)).getValue() == 1){
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx,enmy - 16);
                }
                if(Math.abs(enmy + (((Enemy)enemies.elementAt(i)).getSizeY() / 2) - nasubiP.getNasubiY() - 8) < 8){
                    enemies.addElement(new Enemy(true,false,-1,0,enmx,enmy + 8,16,16,(Image)images.get("mnshot"),1,1,0));
                }
                i++;
                break;
            case 46:
                if(enemies.size() == 2){
                    ((Enemy)enemies.elementAt(i)).setEnemy(200,0);
                    enemies.addElement(new Enemy(true,false,-1,0,0,Math.abs(random.nextInt() % 240),320,0,(Image)images.get("nattow"),0,48,20));
                    if(((Enemy)enemies.elementAt(i)).getHP() < 200){
                        enemies.addElement(new Enemy(true,false,-1,0,0,Math.abs(random.nextInt() % 240),320,0,(Image)images.get("nattow"),0,48,20));
                    }
                    if(((Enemy)enemies.elementAt(i)).getHP() < 100){
                        enemies.addElement(new Enemy(true,false,-1,0,0,Math.abs(random.nextInt() % 240),320,0,(Image)images.get("nattow"),0,48,20));
                    }
                }
                i++;
                break;
            case 47:
                if(i == 0){
                    ((Enemy)enemies.elementAt(i)).setEnemy(200,0);
                    if(random.nextInt() % 15 == 0){
                        enemies.addElement(new Enemy(true,false,-1,0,0,Math.abs(random.nextInt() % 240),320,0,(Image)images.get("nattow"),0,48,20));
                    }
                    if(random.nextInt() % 10 == 0){
                        enemies.addElement(new Enemy(false,false,-1,0,200,Math.abs(random.nextInt() % 240),32,32,(Image)images.get("natto"),1,49,0));
                    }
                }
                i++;
                break;
            case 48:
                if(((Enemy)enemies.elementAt(i)).getValue() == 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setValue(((Enemy)enemies.elementAt(i)).getValue() - 1);
                    if(((Enemy)enemies.elementAt(i)).getValue() < 10){
                        enemies.addElement(new Enemy(true,false,-1,0,144 + random.nextInt() % 145,enmy + (random.nextInt() % 17) - 16,32,32,(Image)images.get("natto"),1,29,0));
                    }
                    i++;
                }
                break;
            case 49:
                if(((Enemy)enemies.elementAt(i)).getHP() != -1 || random.nextInt() % 10 == 0){
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("natto"),1,9,2));
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("natto"),1,9,1));
                    enemies.addElement(new Enemy(false,false,-1,0,enmx,enmy,32,32,(Image)images.get("natto"),1,9,3));
                    enemies.removeElementAt(i);
                    continue;
                }else if(enmx + ((Enemy)enemies.elementAt(i)).getSizeX() < 0){
                    enemies.removeElementAt(i);
                    continue;
                }else{
                    ((Enemy)enemies.elementAt(i)).setEnemy(enmx - 8,enmy);
                    i++;
                }
                break;
            }
        }
        hitCheck();
    }
    
    void hitCheck(){
        int i = 0;
        EnemyDeath:
        while(i < enemies.size()){
            if(isHit(nasubiP.getNasubiX(),nasubiP.getNasubiY(),32,16,NasubiPlane.NasubiHitType,((Enemy)enemies.elementAt(i)).getX(),((Enemy)enemies.elementAt(i)).getY(),((Enemy)enemies.elementAt(i)).getSizeX(),((Enemy)enemies.elementAt(i)).getSizeY(),((Enemy)enemies.elementAt(i)).getHitType()) && !deathLock){
                deathSound.play();
                deathLock = true;
                lockTime = 20;
                nasubiHP--;
            }
            if(!((Enemy)enemies.elementAt(i)).isShot()){
                int j = 0;
                while(j < nasubiP.howManyShots()){
                    if(isHit(nasubiP.getShotX(j),nasubiP.getShotY(j),16,2,NasubiPlane.ShotHitType,((Enemy)enemies.elementAt(i)).getX(),((Enemy)enemies.elementAt(i)).getY(),((Enemy)enemies.elementAt(i)).getSizeX(),((Enemy)enemies.elementAt(i)).getSizeY(),((Enemy)enemies.elementAt(i)).getHitType())){
                        ((Enemy)enemies.elementAt(i)).damage();
                        nasubiP.removeShot(j);
                        if(((Enemy)enemies.elementAt(i)).getHP() == 0){
                            deathSound.play();
                            score += ((Enemy)enemies.elementAt(i)).getScore();
                            if(((Enemy)enemies.elementAt(i)).isBoss()){
                                switch(stage){
                                case 1:
                                    while(enemies.size() > 1){
                                        enemies.removeElementAt(1);
                                    }
                                    lockTime = 20;
                                    break;
                                case 2:
                                    enemies.removeElementAt(0);
                                    while(enemies.size() > 3){
                                        enemies.removeElementAt(3);
                                    }
                                    lockTime = 20;
                                    break;
                                case 3:
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(2)).getX(),((Enemy)enemies.elementAt(2)).getY(),128,128,(Image)images.get("sparrowc"),0,12,0));
                                    while(enemies.size() > 3){
                                        enemies.removeElementAt(2);
                                    }
                                    lockTime = 20;
                                    break;
                                case 4:
                                    while(enemies.size() > 1){
                                        enemies.removeElementAt(1);
                                    }
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),40,40,(Image)images.get("antbody"),0,12,0));
                                    enemies.removeElementAt(0);
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX() - 40,((Enemy)enemies.elementAt(0)).getY(),40,40,(Image)images.get("anthead"),0,12,0));
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX() + 40,((Enemy)enemies.elementAt(0)).getY(),40,40,(Image)images.get("anttail"),0,12,0));
                                    lockTime = 20;
                                    break;
                                case 5:
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),128,128,(Image)images.get("horse"),0,12,0));
                                    while(enemies.size() > 1){
                                        enemies.removeElementAt(0);
                                    }
                                    lockTime = 20;
                                    break;
                                case 6:
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),128,128,(Image)images.get("elephant"),0,12,0));
                                    while(enemies.size() > 1){
                                        enemies.removeElementAt(0);
                                    }
                                    lockTime = 20;
                                    break;
                                case 7:
                                    if(leftEnemy == 0){
                                        enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),128,128,(Image)images.get("wbear"),0,12,0));
                                        while(enemies.size() > 1){
                                            enemies.removeElementAt(0);
                                        }
                                        lockTime = 20;
                                    }else{
                                        while(enemies.size() > 0){
                                            enemies.removeElementAt(0);
                                        }
                                    }
                                    break;
                                case 8:
                                    enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),128,240,(Image)images.get("salad"),0,12,0));
                                    while(enemies.size() > 1){
                                        enemies.removeElementAt(0);
                                    }
                                    lockTime = 20;
                                    break;
                                case 9:
                                    if(((Enemy)enemies.elementAt(0)).getValue() == -1){
                                        enemies.removeElementAt(0);
                                    }else{
                                        enemies.addElement(new Enemy(false,false,-1,0,((Enemy)enemies.elementAt(0)).getX(),((Enemy)enemies.elementAt(0)).getY(),120,240,(Image)images.get("natto2"),0,12,0));
                                        while(enemies.size() > 1){
                                            enemies.removeElementAt(0);
                                        }
                                        lockTime = 240;
                                    }
                                    break;
                                }
                            }else{
                                enemies.removeElementAt(i);
                            }
                            if(stage != 7){
                                leftEnemy--;
                            }
                            if(leftEnemy == 0){
                                bgm.stopPlay();
                                switch(stage){
                                case 1:
                                    enemies.addElement(new Enemy(true,false,1,0,192,56,128,128,(Image)images.get("cat"),0,3,-1));
                                    enemies.addElement(new Enemy(false,true,50,1000,400,400,16,16,(Image)images.get("catcore"),1,4,-1));
                                    break;
                                case 2:
                                    enemies.addElement(new Enemy(false,true,50,2000,400,400,40,16,(Image)images.get("dogcore"),1,11,-1));
                                    enemies.addElement(new Enemy(true,false,1,0,240,0,80,80,(Image)images.get("dog"),0,12,0));
                                    enemies.addElement(new Enemy(true,false,1,0,240,80,80,80,(Image)images.get("dog"),0,12,0));
                                    enemies.addElement(new Enemy(true,false,1,0,240,160,80,80,(Image)images.get("dog"),0,12,0));
                                    break;
                                case 3:
                                    enemies.addElement(new Enemy(false,false,-1,0,320,88,128,32,(Image)images.get("sparrowu"),3,12,0));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,120,128,32,(Image)images.get("sparrowd"),4,12,0));
                                    enemies.addElement(new Enemy(false,true,100,3000,384,56,128,128,(Image)images.get("sparrowc"),5,17,0));
                                    break;
                                case 4:
                                    enemies.addElement(new Enemy(false,true,50,4000,360,100,40,40,(Image)images.get("antbody"),1,23,0));
                                    enemies.addElement(new Enemy(false,false,100,0,320,100,40,40,(Image)images.get("anthead"),1,24,0));
                                    enemies.addElement(new Enemy(false,false,50,0,400,100,40,40,(Image)images.get("anttail"),1,25,0));
                                    break;
                                case 5:
                                    enemies.addElement(new Enemy(false,true,100,5000,352,56,128,128,(Image)images.get("horse"),1,33,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,352,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,384,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,416,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,448,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,24,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,56,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,88,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,120,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,152,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,480,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,448,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,416,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,384,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,352,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,184,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,152,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,120,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,88,32,32,(Image)images.get("horsef"),1,34,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,56,32,32,(Image)images.get("horsef"),1,34,-1));
                                    break;
                                case 6:
                                    enemies.addElement(new Enemy(false,false,-1,0,384,56,128,128,(Image)images.get("elephant"),1,40,-1));
                                    enemies.addElement(new Enemy(false,true,200,7500,352,104,32,32,(Image)images.get("nose"),1,12,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                                    enemies.addElement(new Enemy(false,false,-1,0,320,104,32,32,(Image)images.get("nose"),1,41,-1));
                                    break;
                                case 9:
                                    enemies.addElement(new Enemy(false,true,300,0,400,400,120,240,(Image)images.get("natto1"),1,46,-1));
                                    enemies.addElement(new Enemy(false,true,300,30000,400,400,120,240,(Image)images.get("natto2"),1,47,0));
                                    break;
                                }
                            }
                            continue EnemyDeath;
                        }else{
                            damageSound.play();
                        }
                    }else{
                        j++;
                    }
                }
            }
            i++;
        }
    }
    
    boolean isHit(int aX,int aY,int aSizeX,int aSizeY,Vector aVector,int bX,int bY,int bSizeX,int bSizeY,Vector bVector){
        if(aX - bX - bSizeX < 0 && bX - aX - aSizeX < 0 && aY - bY - bSizeY < 0 && bY - aY - aSizeY < 0){
            for(int i = 0;i < aSizeY;i++){
                for(int j = 0;j < aSizeX;j++){
                    if(aX + j >= bX && aX + j < bX + bSizeX && aY + i >= bY && aY + i < bY + bSizeY && ((Boolean)aVector.elementAt(j + i * aSizeX)).booleanValue() && ((Boolean)bVector.elementAt(aX - bX + j + (aY - bY + i) * bSizeX)).booleanValue()){
                        return true;
                    }
                }
            }
        }
        return false;
    }
    
    public void update(Graphics g){
        paint(g);
    }
    
    public void paint(Graphics g){
        if(starImage == null){
            starImage = createImage(320,240);
            starGraphics = starImage.getGraphics();
            starGraphics.setColor(Color.black);
            starGraphics.fillRect(0,0,320,240);
            for(int i = 1;i < 40;i++){
                drawStar();
            }
        }
        drawStar();
        if(stage == 9){
            bgGraphics.drawImage((Image)images.get("stage9bg"),0,0,this);
        }else{
            bgGraphics.drawImage(starImage,0,0,this);
        }
        stageGraphic();
        bgGraphics.setColor(Color.white);
        bgGraphics.setFont(statusFont);
        if(nasubiHP < 0){
            bgGraphics.drawString("Life   0            Score   "+score,0,16);
            bgGraphics.drawString("Game Over",130,128);
        }else{
            bgGraphics.drawString("Life   "+nasubiHP+"            Score   "+score,0,16);
        }
        g.drawImage(bgImage,0,0,this);
    }
    
    void stageGraphic(){
        switch(stage){
        case 0:
            bgGraphics.setFont(new Font("TimesRoman",Font.PLAIN,32));
            bgGraphics.setColor(Color.blue);
            bgGraphics.drawString("Real Armageddon",0,48);
            bgGraphics.setFont(new Font("TimesRoman",Font.PLAIN,64));
            bgGraphics.setColor(Color.red);
            bgGraphics.drawString("NASUBI",40,128);
            bgGraphics.setColor(Color.yellow);
            bgGraphics.drawString("0",280,128);
            bgGraphics.setColor(Color.white);
            bgGraphics.setFont(statusFont);
            bgGraphics.drawString("Click Start" ,120,200);
            break;
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
            if(deathLock){
                bgGraphics.drawImage((Image)images.get("death"),nasubiP.getNasubiX(),nasubiP.getNasubiY(),this);
            }else{
                bgGraphics.drawImage((Image)images.get("nasubi"),nasubiP.getNasubiX(),nasubiP.getNasubiY(),this);
            }
            for(int i = 0;i < nasubiP.howManyShots();i++){
                bgGraphics.drawImage((Image)images.get("shot"),nasubiP.getShotX(i),nasubiP.getShotY(i),this);
            }
            for(int j = 0;j < enemies.size();j++){
                bgGraphics.drawImage(((Enemy)enemies.elementAt(j)).getImage(),((Enemy)enemies.elementAt(j)).getX(),((Enemy)enemies.elementAt(j)).getY(),this);
            }
            if(lockTime > -1 && !deathLock){
                switch(stage){
                case 1:
                    bgGraphics.drawImage((Image)(images.get("death")),((Enemy)enemies.elementAt(0)).getX() + 48 + (random.nextInt() % 48),((Enemy)enemies.elementAt(0)).getY() + 56 + (random.nextInt() % 56),this);
                    deathSound.play();
                    break;
                case 2:
                    bgGraphics.drawImage((Image)(images.get("death")),264 + (random.nextInt() % 24),112 + (random.nextInt() % 112),this);
                    deathSound.play();
                    break;
                case 3:
                    bgGraphics.drawImage((Image)(images.get("death")),224 + (random.nextInt() % 80),((Enemy)enemies.elementAt(0)).getY() + 56 + (random.nextInt() % 56),this);
                    deathSound.play();
                    break;
                case 4:
                    bgGraphics.drawImage((Image)(images.get("death")),((Enemy)enemies.elementAt(0)).getX() + 4 + (random.nextInt() % 44),((Enemy)enemies.elementAt(0)).getY() + 12 + (random.nextInt() % 12),this);
                    deathSound.play();
                    break;
                case 5:
                    bgGraphics.drawImage((Image)(images.get("death")),208 + (random.nextInt() % 48),112 + (random.nextInt() % 56),this);
                    deathSound.play();
                    break;
                case 6:
                    bgGraphics.drawImage((Image)(images.get("death")),240 + (random.nextInt() % 48),((Enemy)enemies.elementAt(0)).getY() + 56 + (random.nextInt() % 56),this);
                    deathSound.play();
                    break;
                case 7:
                    bgGraphics.drawImage((Image)(images.get("death")),240 + (random.nextInt() % 48),((Enemy)enemies.elementAt(0)).getY() + 56 + (random.nextInt() % 56),this);
                    deathSound.play();
                    break;
                case 8:
                    bgGraphics.drawImage((Image)(images.get("death")),240 + (random.nextInt() % 48),((Enemy)enemies.elementAt(0)).getY() + 112 + (random.nextInt() % 112),this);
                    bgGraphics.drawImage((Image)(images.get("death")),240 + (random.nextInt() % 48),((Enemy)enemies.elementAt(0)).getY() + 112 + (random.nextInt() % 112),this);
                    deathSound.play();
                    break;
                case 9:
                    ((Enemy)enemies.elementAt(0)).setEnemy(200,240 - lockTime);
                    bgGraphics.drawImage((Image)(images.get("shakapan")),228 + (random.nextInt() % 28),88 + (random.nextInt() % 88),this);
                    bgGraphics.drawImage((Image)(images.get("shakapan")),228 + (random.nextInt() % 28),88 + (random.nextInt() % 88),this);
                    deathSound.play();
                    break;
                }
            }
            break;
        case 10:
            bgGraphics.setColor(Color.white);
            bgGraphics.setFont(statusFont);
            if(lockTime > 1450){
                bgGraphics.drawString("Real Armageddon NASUBI0",70,110);
                bgGraphics.drawString("CAST",140,130);
            }else if(lockTime > 1400){
                bgGraphics.drawString("Enemies of Stage 1",100,80);
                bgGraphics.drawImage((Image)(images.get("mcdonald")),144,112,this);
                bgGraphics.drawImage((Image)(images.get("yoshigyu")),34,160,this);
                bgGraphics.drawImage((Image)(images.get("peking")),254,160,this);
                bgGraphics.drawString("McDonalds",120,160);
                bgGraphics.drawString("Yoshi-Gyu",10,220);
                bgGraphics.drawString("Kentucky Fried Peking",180,220);
            }else if(lockTime > 1350){
                bgGraphics.drawString("Enemies of Stage 2",100,80);
                bgGraphics.drawImage((Image)(images.get("ave00")),34,100,this);
                bgGraphics.drawImage((Image)(images.get("ave02")),254,100,this);
                bgGraphics.drawImage((Image)(images.get("subdog")),144,160,this);
                bgGraphics.drawString("Avengelion No.00",0,160);
                bgGraphics.drawString("Avengelion No.02",200,160);
                bgGraphics.drawString("Sub Dog",130,220);
            }else if(lockTime > 1300){
                bgGraphics.drawString("Enemies of Stage 3",100,80);
                bgGraphics.drawImage((Image)(images.get("atom")),84,90,this);
                bgGraphics.drawImage((Image)(images.get("jungle")),204,90,this);
                bgGraphics.drawImage((Image)(images.get("ribbon")),84,178,this);
                bgGraphics.fillRect(212,170,16,32);
                bgGraphics.drawImage((Image)(images.get("jack")),212,170,this);
                bgGraphics.drawString("Astroboy",60,150);
                bgGraphics.drawString("Emperor of Jungle",160,150);
                bgGraphics.drawString("Ribbon Knight",50,230);
                bgGraphics.drawString("Black Jack",180,230);
            }else if(lockTime > 1250){
                bgGraphics.drawString("Enemies of Stage 4",100,80);
                bgGraphics.drawImage((Image)(images.get("sbeko")),84,90,this);
                bgGraphics.drawImage((Image)(images.get("iwambo")),204,90,this);
                bgGraphics.drawImage((Image)(images.get("soji")),84,170,this);
                bgGraphics.drawImage((Image)(images.get("saito")),204,170,this);
                bgGraphics.drawString("Shiro-beko",60,150);
                bgGraphics.drawString("Iwambo",200,150);
                bgGraphics.drawString("Soji Okita",60,230);
                bgGraphics.drawString("Hajime Saito",170,230);
            }else if(lockTime > 1200){
                bgGraphics.drawString("Enemies of Stage 5",100,80);
                bgGraphics.drawImage((Image)(images.get("bluebigm")),34,102,this);
                bgGraphics.drawImage((Image)(images.get("ufo")),254,90,this);
                bgGraphics.drawImage((Image)(images.get("kabikill")),128,114,this);
                bgGraphics.drawImage((Image)(images.get("barbados")),34,178,this);
                bgGraphics.drawImage((Image)(images.get("invader")),254,178,this);
                bgGraphics.drawString("Hyper McDonalds",0,150);
                bgGraphics.drawString("U.F.O.",250,150);
                bgGraphics.drawString("Kabi-killer",120,206);
                bgGraphics.drawString("Amaryllis",20,230);
                bgGraphics.drawString("Invader",240,230);
            }else if(lockTime > 1150){
                bgGraphics.drawString("Enemies of Stage 6",100,80);
                bgGraphics.drawImage((Image)(images.get("yellow")),34,90,this);
                bgGraphics.drawImage((Image)(images.get("redangel")),254,90,this);
                bgGraphics.drawImage((Image)(images.get("bluemoai")),144,114,this);
                bgGraphics.drawImage((Image)(images.get("greenman")),42,170,this);
                bgGraphics.drawImage((Image)(images.get("power")),254,170,this);
                bgGraphics.drawString("Yellow Yellow Happy",0,150);
                bgGraphics.drawString("Rad Angel",240,150);
                bgGraphics.drawString("Ao-no-sumibito",100,206);
                bgGraphics.drawString("Green Man",20,230);
                bgGraphics.drawString("Power",250,230);
            }else if(lockTime > 1100){
                bgGraphics.drawString("The Boss of Stage 1",0,110);
                bgGraphics.drawString("Cat",70,150);
                bgGraphics.drawImage((Image)(images.get("cat")),192,56,this);
                bgGraphics.drawImage((Image)(images.get("catcore")),200,100,this);
            }else if(lockTime > 1050){
                bgGraphics.drawString("The Boss of Stage 2",0,110);
                bgGraphics.drawString("Dog",70,150);
                bgGraphics.drawImage((Image)(images.get("dogcore")),240,128,this);
                bgGraphics.drawImage((Image)(images.get("dog")),240,80,this);
            }else if(lockTime > 1000){
                bgGraphics.drawString("The Boss of Stage 3",0,110);
                bgGraphics.drawString("Sparrow",70,150);
                bgGraphics.drawImage((Image)(images.get("sparrowu")),128,88,this);
                bgGraphics.drawImage((Image)(images.get("sparrowd")),128,120,this);
                bgGraphics.drawImage((Image)(images.get("sparrowc")),192,56,this);
            }else if(lockTime > 950){
                bgGraphics.drawString("The Boss of Stage 4",0,110);
                bgGraphics.drawString("Ant",70,150);
                bgGraphics.drawImage((Image)(images.get("antbody")),240,100,this);
                bgGraphics.drawImage((Image)(images.get("anthead")),200,100,this);
                bgGraphics.drawImage((Image)(images.get("anttail")),280,100,this);
            }else if(lockTime > 900){
                bgGraphics.drawString("The Boss of Stage 5",0,110);
                bgGraphics.drawString("Horse",70,150);
                bgGraphics.drawImage((Image)(images.get("horse")),192,56,this);
            }else if(lockTime > 850){
                bgGraphics.drawString("The Boss of Stage 6",0,110);
                bgGraphics.drawString("Elephant",70,150);
                bgGraphics.drawImage((Image)(images.get("elephant")),192,112,this);
                bgGraphics.drawImage((Image)(images.get("nose")),160,160,this);
                bgGraphics.drawImage((Image)(images.get("nose")),128,160,this);
                bgGraphics.drawImage((Image)(images.get("nose")),96,160,this);
                bgGraphics.drawImage((Image)(images.get("nose")),64,160,this);
                bgGraphics.drawImage((Image)(images.get("nose")),32,160,this);
                bgGraphics.drawImage((Image)(images.get("nose")),0,160,this);
            }else if(lockTime > 800){
                bgGraphics.drawString("The Boss of Stage 7",0,110);
                bgGraphics.drawString("White Bear",70,150);
                bgGraphics.drawImage((Image)(images.get("wbear")),192,56,this);
            }else if(lockTime > 750){
                bgGraphics.drawString("The Boss of Stage 8",0,110);
                bgGraphics.drawString("Salad",70,150);
                bgGraphics.drawImage((Image)(images.get("salad")),192,0,this);
            }else if(lockTime > 700){
                bgGraphics.drawString("Boss of The Final Stage",0,110);
                bgGraphics.drawString("Natto God(I)",70,150);
                bgGraphics.drawImage((Image)(images.get("natto1")),200,0,this);
            }else if(lockTime > 650){
                bgGraphics.drawString("The Last Boss",0,110);
                bgGraphics.drawString("Natto God(II)",70,150);
                bgGraphics.drawImage((Image)(images.get("natto2")),200,0,this);
            }else if(lockTime > 600){
                bgGraphics.drawString("Enemy of Final Stage",0,110);
                bgGraphics.drawString("Metal Nasubi",70,150);
                bgGraphics.drawImage((Image)(images.get("mnasubi")),240,104,this);
            }else if(lockTime > 550){
                bgGraphics.drawString("Your Fighter",0,110);
                bgGraphics.drawString("Nasubi Prototype",70,150);
                bgGraphics.drawImage((Image)(images.get("nasubi")),240,112,this);
            }else if(lockTime > 500){
                bgGraphics.drawString("Real Armageddon NASUBI0",70,110);
                bgGraphics.drawString("STAFF",140,130);
            }else if(lockTime > 500){
                bgGraphics.drawString("Real Armageddon NASUBI0",70,110);
                bgGraphics.drawString("STAFF",130,130);
            }else if(lockTime > 450){
                bgGraphics.drawString("Program",130,110);
                bgGraphics.drawString("Natto God",130,130);
            }else if(lockTime > 400){
                bgGraphics.drawString("Sound",140,110);
                bgGraphics.drawString("Natto God",130,130);
            }else if(lockTime > 350){
                bgGraphics.drawString("Graphic",140,110);
                bgGraphics.drawString("Natto God",130,130);
            }else if(lockTime > 300){
                bgGraphics.drawString("Back Ground Music",100,110);
                bgGraphics.drawString("Natto God",130,130);
            }else if(lockTime > 250){
                bgGraphics.drawString("Special Thanks",120,50);
                bgGraphics.drawString("Ocha-ppoi",130,90);
                bgGraphics.drawString("Miyuki Idenoshita",110,110);
                bgGraphics.drawString("Gentoku Makitsubo",110,130);
                bgGraphics.drawString("Shunsuke Tanigawa",110,150);
                bgGraphics.drawString("Ryo Kawashita",120,170);
                bgGraphics.drawString("ITTON",140,190);
                bgGraphics.drawString("Hoshi-wo-otosu-mono",100,210);
            }else if(lockTime > 200){
                bgGraphics.drawString("Kaeru",140,90);
                bgGraphics.drawString("Yuki Genjo",130,110);
                bgGraphics.drawString("Shuichiro Morinobu",100,130);
                bgGraphics.drawString("Hidemasa Murozumi",110,150);
                bgGraphics.drawString("Masashi Nakato",120,170);
                bgGraphics.drawString("Takahiro Inoue",120,190);
                bgGraphics.drawString("Shohei Yamada",110,210);
            }else if(lockTime > 150){
                bgGraphics.drawString("Test Player",120,40);
                bgGraphics.drawString("Leader Tsubota",120,80);
                bgGraphics.drawString("Miyuki Idenoshita",110,100);
                bgGraphics.drawString("Gentoku Makitsubo",110,120);
                bgGraphics.drawString("Shunsuke Tanigawa",110,140);
                bgGraphics.drawString("Ryo Kawashita",120,160);
                bgGraphics.drawString("ITTON",140,180);
                bgGraphics.drawString("Yami-no-mieru-oka",110,200);
                bgGraphics.drawString("Kaeru",140,220);
            }else if(lockTime > 100){
                bgGraphics.drawString("Produce",130,110);
                bgGraphics.drawString("Natto God",130,130);
            }else if(lockTime > 50){
                bgGraphics.drawString("Presented by",120,110);
                bgGraphics.drawString("Microworld Dream Club",90,130);
            }else{
                bgGraphics.drawString("The End",130,100);
                bgGraphics.drawString("Thanks for Your Playing!",90,120);
                bgGraphics.drawString("Click to Play Again!",100,140);
            }
            break;
        }
    }
    
    void drawStar(){
        starGraphics.drawImage(starImage,-8,0,this);
        starGraphics.setColor(Color.black);
        starGraphics.fillRect(312,0,8,240);
        int r = random.nextInt() % 256;
        if(r < 0){
            r = -r;
        }
        int g = random.nextInt() % 256;
        if(g < 0){
            g = -g;
        }
        int b = random.nextInt() % 256;
        if(b < 0){
            b = -b;
        }
        starGraphics.setColor(new Color(r,g,b));
        int h = random.nextInt() % 30;
        if(h < 0){
            h = -h;
        }
        starGraphics.fillRect(315,h * 8 + 3,2,2);
    }
    
    public synchronized boolean mouseDown(Event e,int x,int y){
        mouseX = x;
        mouseY = y;
        if(lockTime == -1){
            switch(stage){
            case 0:
                if(bgm == null){
                    bgm = (BGMPlayer)getAppletContext().getApplet("bgm");
                }
                bgm.stopPlay();
                nasubiP = new NasubiPlane(320);
                nasubiP.setPlane(0,112);
                leftEnemy = 30;
                stage = 1;
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
            case 8:
            case 9:
                if(bgm == null){
                    bgm = (BGMPlayer)getAppletContext().getApplet("bgm");
                }
                shotSound.play();
                nasubiP.shot();
                break;
            }
        }else if(lockTime == 0){
            bgm.stopPlay();
            lockTime = -1;
            enemies = new Vector();
            if(nasubiHP < 0){
                stage = 0;
                score = 0;
                oneUp = 1000;
            }else if(!deathLock){
                stage++;
                if(stage == 7){
                    leftEnemy = 121;
                }else if(stage == 8){
                    leftEnemy = 0;
                    enemies.addElement(new Enemy(false,true,250,20000,192,0,128,240,(Image)images.get("salad"),1,43,0));
                }else if(stage == 10){
                    leftEnemy = 0;
                    lockTime = 1500;
                }else if(stage == 11){
                    leftEnemy = 30;
                    stage = 1;
                }else{
                    leftEnemy = 30;
                }
            }else if(stage == 7){
                switch(leftEnemy){
                case 0:
                    enemies.addElement(new Enemy(false,true,200,10000,400,400,128,128,(Image)images.get("wbear"),1,42,-20));
                    enemies.addElement(new Enemy(false,false,-1,0,288,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,288,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,256,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,256,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,224,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,224,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,192,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,192,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,160,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,160,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,128,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,128,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,96,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,96,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,64,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,64,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,32,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,32,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,0,-32,32,32,(Image)images.get("wbearice"),1,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,0,240,32,32,(Image)images.get("wbearice"),1,12,0));
                    break;
                case 20:
                    enemies.addElement(new Enemy(false,false,-1,0,192,56,128,128,(Image)images.get("elephant"),1,40,-1));
                    enemies.addElement(new Enemy(false,true,200,7500,160,104,32,32,(Image)images.get("nose"),1,12,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    break;
                case 40:
                    enemies.addElement(new Enemy(false,true,100,5000,160,56,128,128,(Image)images.get("horse"),1,33,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,160,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,192,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,224,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,256,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,56,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,88,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,120,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,152,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,256,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,224,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,192,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,160,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,152,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,120,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,88,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,56,32,32,(Image)images.get("horsef"),1,34,-1));
                    break;
                case 60:
                    enemies.addElement(new Enemy(false,true,50,4000,240,100,40,40,(Image)images.get("antbody"),1,23,0));
                    enemies.addElement(new Enemy(false,false,100,0,200,100,40,40,(Image)images.get("anthead"),1,24,0));
                    enemies.addElement(new Enemy(false,false,50,0,280,100,40,40,(Image)images.get("anttail"),1,25,0));
                    break;
                case 80:
                    enemies.addElement(new Enemy(false,false,-1,0,128,88,128,32,(Image)images.get("sparrowu"),3,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,128,120,128,32,(Image)images.get("sparrowd"),4,12,0));
                    enemies.addElement(new Enemy(false,true,100,3000,192,56,128,128,(Image)images.get("sparrowc"),5,17,0));
                    break;
                case 100:
                    enemies.addElement(new Enemy(false,true,50,2000,400,400,40,16,(Image)images.get("dogcore"),1,11,-1));
                    enemies.addElement(new Enemy(true,false,1,0,240,0,80,80,(Image)images.get("dog"),0,12,0));
                    enemies.addElement(new Enemy(true,false,1,0,240,80,80,80,(Image)images.get("dog"),0,12,0));
                    enemies.addElement(new Enemy(true,false,1,0,240,160,80,80,(Image)images.get("dog"),0,12,0));
                    break;
                case 120:
                    enemies.addElement(new Enemy(true,false,1,0,192,56,128,128,(Image)images.get("cat"),0,3,-1));
                    enemies.addElement(new Enemy(false,true,50,1000,400,400,16,16,(Image)images.get("catcore"),1,4,-1));
                    break;
                }
            }else if(stage == 8){
                enemies.addElement(new Enemy(false,true,250,20000,192,0,128,240,(Image)images.get("salad"),1,43,0));
            }else if(leftEnemy < 1){
                switch(stage){
                case 1:
                    enemies.addElement(new Enemy(true,false,1,0,192,56,128,128,(Image)images.get("cat"),0,3,-1));
                    enemies.addElement(new Enemy(false,true,50,1000,400,400,16,16,(Image)images.get("catcore"),1,4,-1));
                    break;
                case 2:
                    enemies.addElement(new Enemy(false,true,50,2000,400,400,40,16,(Image)images.get("dogcore"),1,11,-1));
                    enemies.addElement(new Enemy(true,false,1,0,240,0,80,80,(Image)images.get("dog"),0,12,0));
                    enemies.addElement(new Enemy(true,false,1,0,240,80,80,80,(Image)images.get("dog"),0,12,0));
                    enemies.addElement(new Enemy(true,false,1,0,240,160,80,80,(Image)images.get("dog"),0,12,0));
                    break;
                case 3:
                    enemies.addElement(new Enemy(false,false,-1,0,128,88,128,32,(Image)images.get("sparrowu"),3,12,0));
                    enemies.addElement(new Enemy(false,false,-1,0,128,120,128,32,(Image)images.get("sparrowd"),4,12,0));
                    enemies.addElement(new Enemy(false,true,100,3000,192,56,128,128,(Image)images.get("sparrowc"),5,17,0));
                    break;
                case 4:
                    enemies.addElement(new Enemy(false,true,50,4000,240,100,40,40,(Image)images.get("antbody"),1,23,0));
                    enemies.addElement(new Enemy(false,false,100,0,200,100,40,40,(Image)images.get("anthead"),1,24,0));
                    enemies.addElement(new Enemy(false,false,50,0,280,100,40,40,(Image)images.get("anttail"),1,25,0));
                    break;
                case 5:
                    enemies.addElement(new Enemy(false,true,100,5000,160,56,128,128,(Image)images.get("horse"),1,33,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,160,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,192,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,224,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,256,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,24,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,56,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,88,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,120,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,152,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,288,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,256,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,224,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,192,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,160,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,184,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,152,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,120,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,88,32,32,(Image)images.get("horsef"),1,34,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,56,32,32,(Image)images.get("horsef"),1,34,-1));
                    break;
                case 6:
                    enemies.addElement(new Enemy(false,false,-1,0,192,56,128,128,(Image)images.get("elephant"),1,40,-1));
                    enemies.addElement(new Enemy(false,true,200,7500,160,104,32,32,(Image)images.get("nose"),1,12,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    enemies.addElement(new Enemy(false,false,-1,0,128,104,32,32,(Image)images.get("nose"),1,41,-1));
                    break;
                case 9:
                    enemies.addElement(new Enemy(false,true,300,0,400,400,120,240,(Image)images.get("natto1"),1,46,-1));
                    enemies.addElement(new Enemy(false,true,300,30000,400,400,120,240,(Image)images.get("natto2"),1,47,0));
                    break;
                }
            }
            deathLock = false;
            switch(stage){
            case 0:
                nasubiP = null;
                nasubiHP = 2;
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 9:
                nasubiP = new NasubiPlane(320);
                nasubiP.setPlane(0,112);
                if(enemies.size() == 0){
                    leftEnemy = 15 + (leftEnemy / 2);
                }
                break;
            case 7:
            case 8:
            case 10:
                nasubiP = new NasubiPlane(320);
                nasubiP.setPlane(0,112);
                break;
            }
        }
        return true;
    }
    public boolean mouseMove(Event e,int x,int y){
        mouseX = x;
        mouseY = y;
        return true;
    }
    
}

class NasubiPlane{
    
    private int x;
    private int y;
    private Vector shotX;
    private Vector shotY;
    private int maxX;
    static Vector NasubiHitType;
    static Vector ShotHitType;
    
    static{
        NasubiHitType = new Vector(512);
        while(NasubiHitType.size() < 224){
            NasubiHitType.addElement(new Boolean(false));
        }
        while(NasubiHitType.size() < 288){
            NasubiHitType.addElement(new Boolean(true));
        }
        while(NasubiHitType.size() < 512){
            NasubiHitType.addElement(new Boolean(false));
        }
        ShotHitType = new Vector(32);
        while(ShotHitType.size() < 32){
            ShotHitType.addElement(new Boolean(true));
        }
    }
    
    NasubiPlane(int x){
        shotX = new Vector();
        shotY = new Vector();
        maxX = x;
    }
    
    void setPlane(int x,int y){
        this.x = x;
        this.y = y;
    }
    
    synchronized void shot(){
        shotX.addElement(new Integer(x + 16));
        shotY.addElement(new Integer(y + 7));
    }
    
    synchronized void removeShot(int n){
        shotX.removeElementAt(n);
        shotY.removeElementAt(n);
    }
    
    int getNasubiX(){
        return x;
    }
    
    int getNasubiY(){
        return y;
    }
    
    synchronized int getShotX(int n){
        return ((Integer)(shotX.elementAt(n))).intValue();
    }
    
    synchronized int getShotY(int n){
        return ((Integer)(shotY.elementAt(n))).intValue();
    }
    
    synchronized int howManyShots(){
        return shotX.size();
    }
    
    synchronized void moveShot(){
        int i = 0;
        while(i < shotX.size()){
            int x = getShotX(i) + 16;
            if(x < maxX){
                shotX.setElementAt(new Integer(x),i++);
            }else{
                removeShot(i);
            }
        }
    }
    
}

class Enemy{
    
    private boolean isShot;
    private boolean isBoss;
    private int HP;
    private int score;
    private int x;
    private int y;
    private int sizeX;
    private int sizeY;
    private Image image;
    private Vector hitType;
    private int moveType;
    private int v;
    
    Enemy(boolean is,boolean ib,int h,int s,int x,int y,int sx,int sy,Image i,int ht,int mt,int v){
        isShot = is;
        isBoss = ib;
        HP = h;
        score = s;
        this.x = x;
        this.y = y;
        sizeX = sx;
        sizeY = sy;
        image = i;
        hitType = hitToVector(sx,sy,ht);
        moveType = mt;
        this.v = v;
    }
    
    int getHP(){
        return HP;
    }
    
    void damage(){
        HP--;
    }
    
    boolean isShot(){
        return isShot;
    }
    
    boolean isBoss(){
        return isBoss;
    }
    
    int getScore(){
        return score;
    }
    
    Image getImage(){
        return image;
    }
    
    void setEnemy(int x,int y){
        this.x = x;
        this.y = y;
    }
    
    int getX(){
        return x;
    }
    
    int getY(){
        return y;
    }
    
    int getSizeX(){
        return sizeX;
    }
    
    int getSizeY(){
        return sizeY;
    }
    
    void setValue(int val){
        v = val;
    }
    
    int getValue(){
        return v;
    }
    
    Vector getHitType(){
        return hitType;
    }
    
    int getMoveType(){
        return moveType;
    }
    
    private static Vector hitToVector(int sizeX,int sizeY,int type){
        Vector vector = new Vector(sizeX * sizeY);
        for(int i = 0;i < sizeX * sizeY;i++){
            switch(type){
            case 0:
                vector.addElement(new Boolean(false));
                break;
            case 1:
                vector.addElement(new Boolean(true));
                break;
            case 2:
                vector.addElement(new Boolean((i > 461 && i < 466) || (i > 493 && i < 498) || (i > 525 && i < 530) || (i > 557 && i < 562)));
                break;
            case 3:
                vector.addElement(new Boolean((i / 128) + ((i % 128) / 4) > 30));
                break;
            case 4:
                vector.addElement(new Boolean((i / 128) - ((i % 128) / 4) < 1));
                break;
            case 5:
                vector.addElement(new Boolean((i / 128 > 31) && (i / 128 < 96) && (i % 128 == 65)));
                break;
            }
        }
        return vector;
    }
    
}